unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    PaintBox1: TPaintBox;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
    function d2(x1,y1,x2,y2:single):single;
    m,x,y,ax,ay,vx,vy:array[1..1000] of single;
    n:integer;

  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var i:integer;
begin
  timer1.enabled:=not(timer1.enabled);
  if not(timer1.enabled) then button1.caption:='';
  if timer1.enabled then
  begin
     button1.caption:='';
     n:=StrToInt(edit1.text);
     if (n<1)or(n>1000) then n:=1;
     for i:=1 to n do
     begin
        x[i]:=random*512;
        y[i]:=random*512;
        m[i]:=1;
        ax[i]:=0;
        ay[i]:=0;
        vx[i]:=0;
        vy[i]:=0;
     end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

end;

procedure TForm1.PaintBox1Click(Sender: TObject);
begin

end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i,j:integer; ag,dst2,dst,ca,sa:single; k:integer; q:single;
begin
   k:=9;
   q:=1;

   for i:=1 to n do
   begin
      ax[i]:=0;
      ay[i]:=0;
      for j:=1 to n do
        if i<>j then
        begin

        // 
          dst2:=d2(x[i],y[i],x[j],y[j]);
          dst:=dst2;
          ca:=0; sa:=0;
          if dst<>0 then begin ca:=(x[j]-x[i])/dst; sa:=(y[j]-y[i])/dst; end;

          //  
          ag:=0;
          if dst2>=1000  then ag:=sqr(q)*k/sqr(dst2);
          ax[i]:=ax[i]+ag*ca;
          ay[i]:=ay[i]+ag*sa;
          if dst2<=1000 then ag:=-sqr(q)*k/sqr(dst2);
          ax[i]:=ax[i]+ag*ca;
          ay[i]:=ay[i]+ag*sa;
        end;

      // 
      vx[i]:=vx[i]+ax[i];
      vy[i]:=vy[i]+ay[i];

      //  
      x[i]:=x[i]+vx[i];
      y[i]:=y[i]+vy[i];

      // 
      if x[i]>paintbox1.Width-m[i] then
      begin
        x[i]:=paintbox1.Width-m[i];
        vx[i]:=-vx[i];
      end;

      if x[i]<m[i] then
      begin
        x[i]:=m[i];
        vx[i]:=-vx[i];
      end;

      if y[i]>paintbox1.Height-m[i] then
      begin
        y[i]:=paintbox1.Height-m[i];
        vy[i]:=-vy[i];
      end;

      if y[i]<m[i] then
      begin
        y[i]:=m[i];
        vy[i]:=-vy[i];
      end;
   end;
   paintbox1.canvas.brush.color:=clWhite;
   paintbox1.Canvas.clear;
   paintbox1.canvas.pen.color:=clBlue;
   paintbox1.canvas.brush.color:=clBlue;
   for i:=1 to n do
   begin
      paintbox1.canvas.ellipse(trunc(x[i]-m[i]*5),trunc(y[i]-m[i]*5),
                               trunc(x[i]+m[i]*5),trunc(y[i]+m[i]*5));
   end;
end;

function TForm1.d2(x1,y1,x2,y2:single):single;
begin
   d2:=sqrt(sqr(x2-x1)+sqr(y2-y1));
end;

initialization
  {$I unit1.lrs}

end.

